﻿------------------------------------------------------------------------------------------
--Bar Creation----------------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))

--local width, height = 300, 24
local RAID_CLASS_COLORS = RAID_CLASS_COLORS
local GetSpellInfo = GetSpellInfo
local UnitClass = UnitClass
local IsAddOnLoaded = IsAddOnLoaded

function SN:CreateBar(group, cooldown, duration, caster, guid, spell, width, height, fontSize, font, texture)

	--Make our lives easier with some variables
	local class, classFileName, classID = UnitClass(caster)
	local bar

	--Start the CD Timer
	if (IsAddOnLoaded("ElvUI")) then
		if group == F.debuffs then
			bar = T:NewBar(nil, width, height, texture)
		else
			bar = T:NewBar(nil, width, height, texture)
		end
		SN:SNCreateBG(bar, "StatusBar")
	else
		if group == F.debuffs then
			bar = T:NewBar(nil, width, height, texture)
		else
			bar = T:NewBar(nil, width, height + 8, texture)
		end
		bar:SetAlpha(1)
		bar:SetBackdrop({
		bgFile = M.media.blankTex, 
		edgeFile = M.media.blankTex, 
		tile = false, tileSize = 0, edgeSize = 2, 
		insets = { left = -2, right = 2, top = 2, bottom = -2 }
		})
		bar:SetBackdropColor(0, 0, 0, 0)
		bar:SetBackdropBorderColor(0.1, 0.1, 0.1, 1)
	end
	
	--Grab the player's class color and the icon of the spell
	local colortmp = RAID_CLASS_COLORS[classFileName]
	local color = { colortmp.r, colortmp.g, colortmp.b }
	local _, _, icon = GetSpellInfo(cooldown)
	
	bar:SetIcon(icon)
	bar:SetColor(color)
	bar:SetDuration(duration)
	bar:SetDurationFont(font, fontSize)
	bar:SetLabelFont(font, fontSize)
	
	--Setup the data keys that the bar will hold
	bar:SetData("SN:arg1", group)
	bar:SetData("SN:arg2", cooldown)
	bar:SetData("SN:arg3", guid)
	bar:SetData("SN:arg4", caster)
	bar:SetData("SN:arg5", spell)
	bar:SetData("SN:arg6", classID)
	bar:SetData("SN:arg7", duration)
	bar.TimeSinceLastUpdate = 0
	
	--Make sure only the CD monitor gets the caster and spell names
	if group == F.debuffs then
		bar:SetLabel(spell)
	elseif group == F.cooldowns then
		bar:SetLabel(caster.."       "..spell)
	end
	--bar:RegisterCallback("FancyBar_BarStop", BarCleanup)
	group:Add(bar)
	bar:Start()
end

--function SN:BarCleanup()
--	collectgarbage("collect")
--end
